"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var mobx_react_1 = require("mobx-react");
__export(require("mobx-react"));
var InjectStoresSymbol = '@@InjectStoresSymbol';
function observer(target) {
    var stores = Reflect.getOwnMetadata(InjectStoresSymbol, target);
    if (stores && stores.length) {
        return mobx_react_1.inject.apply(void 0, stores)(target);
    }
    return target;
}
exports.observer = observer;
function inject(name) {
    return function (prototype, key) {
        var descriptor = Object.getOwnPropertyDescriptor(prototype, key);
        var constructor = prototype.constructor;
        var stores = Reflect.getOwnMetadata(InjectStoresSymbol, constructor);
        var newStores = stores ? stores.concat(key) : [key];
        Object.defineProperty(prototype, key, {
            enumerable: true,
            configurable: true,
            get: function () {
                return this.props[name == undefined ? key : name];
            }
        });
    };
}
exports.inject = inject;
